function main16Par(fMRI)

%this is the main code for 3DFPCA


%%%%%%%%%%%demean the data
data=de_mean(fMRI);


[J1,J2,J3,T]=size(data);
grid1 = 1:1:J1;
grid2 = 1:1:J2;
grid3 = 1:1:J3;

%generating data grid
%the data grid can be saved and reused for dataset of same size
datagrid=zeros(J1*J2*J3,3);
ind=1;
for g1=grid1
        for g2 =grid2
            for g3 =grid3
                datagrid(ind,:)=[g1,g2,g3];
                ind=ind+1;
            end
        end
end
datagrid=datagrid(1:ind-1,:); 
size(datagrid)


% generating datapoints
datapoints = zeros(length(grid1)*length(grid2)*length(grid3)*T,2);
ind =  1;
for tt = 1:T
tt
    for g1=grid1
        for g2 =grid2
            for g3 =grid3
                datapoints(ind,:)=[data(g1,g2,g3,tt),tt];
                ind=ind+1;
            end
        end
    end
end



%parameters of Bsplines
nobs=T; %
x=grid1;y=grid2;z=grid3;
kx=4;ky=4;kz=4;


%  devide divide [min, max] into #knots numbers.
numknots1=16; %8
numknots2=16; %8
numknots3=16; %4


% see the boundaries of the 3 dimensions
mn1 = min(datagrid(:,1))-1; mx1 = max(datagrid(:,1))+1;  
mn2 = min(datagrid(:,2))-1; mx2 = max(datagrid(:,2))+1;  
mn3 = min(datagrid(:,3))-1; mx3 = max(datagrid(:,3))+1;  

% equally divide [min, max] into #knots numbers. 8 8 4
knots1 = sort(linspace(mn1,mx1,numknots1));
% expand the vector by repeating first k1 times, last k1 times, like 0 0 0
% 6.5714........ 46 46 46 ; 1*12
knots1 = augknt(knots1,kx);
knots2 = sort(linspace(mn2,mx2,numknots2)) ;
knots2 = augknt(knots2,ky);
knots3 = sort(linspace(mn3,mx3,numknots3)) ;
knots3 = augknt(knots3,kz);
nx=numknots1+2;ny=numknots2+2;nz=numknots3+2;
Nx=J1;%91
Ny=J2;%109
Nz=J3;%91


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Coefficient matrix C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Cmat=zeros(nobs,nx*ny*nz);
for i=1:nobs
    sig=datapoints(1+(i-1)*J1*J2*J3:i*J1*J2*J3,1);%only the signal data for t=i
    v=zeros(J1,J2,J3);
    maxSig=max(sig);minSig=min(sig);
    sig = sig - minSig;
    sig = (sig * 63/(maxSig-minSig)) + 1;
    for j=1:1:length(sig)
        coord=datagrid(j,:);
        v(coord(1),coord(2),coord(3))=sig(j);      
    end
    %v=v(13:51,13:62,:);

    coefs1 = reshape(v,Nx,Ny*Nz);
    sp1 = spap2(knots1,kx,x,coefs1.');
    coefs2 = reshape(fnbrk(sp1,'c'),Ny,Nz*nx); 
    sp2 = spap2(knots2,ky,y,coefs2.');
    coefs3 = reshape(fnbrk(sp2,'c'),Nz,nx*ny); 
    sp3 = spap2(knots3,kz,z,coefs3.');
    coefs = reshape(fnbrk(sp3,'c'),nx,ny,nz);
    
    Cmat(i,:)=reshape(coefs,1,nx*ny*nz);
end
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% %Integration Matrix W %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



xv = 1:0.5:J1; yv = 1:0.5:J2;zv=1:0.5:J3;
coef_x=spcol(knots1,kx,xv);
coef_y=spcol(knots2,ky,yv);
coef_z=spcol(knots3,kz,zv);
Jmat=zeros(nx^3,nx^3);

matlabpool close force
matlabpool open 

parfor i=1:(nx^3)
    i
    temp=zeros(1,nx^3);
    for j=1:(nx^3)
        modu1=mod(i,(nx^2));
        if(modu1==0)
            index_xi=nx;
            index_yi=nx;
            index_zi=floor(i/(nx^2));
        else
            index_zi=floor(i/(nx^2))+1;
            if(mod(modu1,nx)==0)
                index_xi=nx;
                index_yi=floor(modu1/nx);
            else
                index_xi=mod(modu1,nx);
                index_yi=floor(modu1/nx)+1;
            end
        end
        
        modu2=mod(j,(nx^2));
        if(modu2==0)
            index_xj=nx;
            index_yj=nx;
            index_zj=floor(j/(nx^2));%denote B_{index_zi}(z)
        else
            index_zj=floor(j/(nx^2))+1;
            if(mod(modu2,nx)==0)
                index_xj=nx;
                index_yj=floor(modu2/nx);
            else
                index_xj=mod(modu2,nx);
                index_yj=floor(modu2/nx)+1;
            end
        end
        
        coefx=coef_x(:,index_xi).*coef_x(:,index_xj);
        coefy=coef_y(:,index_yi).*coef_y(:,index_yj);
        coefz=coef_z(:,index_zi).*coef_z(:,index_zj);
        
        temp(j)=0.5^3*sum(reshape(reshape((coefx').'*(coefy'),1,(2*J1-1)*(2*J2-1)).'*(coefz'),1,(2*J1-1)*(2*J2-1)*(2*J3-1)));
    end
    Jmat(i,:)=temp;
end




matlabpool close

Wmat=(Jmat+Jmat')/2;
Lmat=chol(Wmat);
Lmatinv=inv(Lmat);

LHSmat=Lmat*(Cmat'*Cmat./size(Cmat,1))*Lmat';

% Eigenanalysis
nharm=20;
LHSmat = (LHSmat + LHSmat')./2;
[eigvecs, eigvals] = eig(LHSmat);
[eigvals, indsrt ] = sort(diag(eigvals));
eigvecs = eigvecs(:,indsrt);
neig    = nx*ny*nz;
indx    = neig + 1 - (1:nharm);
eigvals = eigvals(neig + 1 - (1:neig));
eigvecs = eigvecs(:,indx);
sumvecs = sum(eigvecs);
eigvecs(:,sumvecs < 0) = -eigvecs(:,sumvecs < 0);

varprop = eigvals(1:nharm)./sum(eigvals);

harmcoef  = Lmatinv * eigvecs; %coefs for eigen functions 512x2
harmscr   = Cmat * Lmat' * eigvecs; %scors 55x2
fdhatcoef = harmcoef*harmscr'; %coefs for the estimated functions 512x55
%errors = ztry - spcol(knotsx_try,kxtry,xtry)*coefs_try*spcol(knotsy_try,kytry,ytry).';
coefs_eigen1=reshape(harmcoef(:,1),nx,ny,nz);%coefs of eigenfunction1 in Tensor form 8x8x8
coefs_eigen2=reshape(harmcoef(:,2),nx,ny,nz);%8x8x8
est_eigen1=fnval(spmak({knots1,knots2,knots3},coefs_eigen1),{x,y,z}); %vals for eigenfunction1 39x50x8
est_eigen2=fnval(spmak({knots1,knots2,knots3},coefs_eigen2),{x,y,z}); %vals for eigenfunction1 39x50x8


clear fMRI
clear data
%save('dp1.mat','datapoints')
clear datapoints
save('Result_avgMask_numknots16.mat','-v7.3')





end